import CryptoJS from "crypto-js";
// 加密函数
const encryptData = (data, key) => {
	const encryptedData = CryptoJS.AES.encrypt(
		JSON.stringify(data),
		key
	).toString();
	return encryptedData;
};

// 解密函数
const decryptData = (encryptedData, key) => {
	const decryptedBytes = CryptoJS.AES.decrypt(encryptedData, key);
	const decryptedData = JSON.parse(decryptedBytes.toString(CryptoJS.enc.Utf8));
	return decryptedData;
};

const EncryptionPlugin = {
	install: (app, { key = "my-secret-key" } = {}) => {
		// 为组件提供插件
		app.provide("encryptionPlugin", {
			encryptData: (data) => encryptData(data, key),
			decryptData: (data) => decryptData(data, key),
		});
		app.config.globalProperties.$encryptionPlugin = {
			encryptData: (data) => encryptData(data, key),
			decryptData: (data) => decryptData(data, key),
		};
	},
};

export default EncryptionPlugin;